var sqlite3 = require('sqlite3');
var open = require('sqlite').open;
var question_repository = require('../repositories/question_repository');
var builder = require('xmlbuilder');
var fs = require('fs')
var JSZip = require('jszip');
var path = require('path');

var repository = {
    create: async (entity) => {
        // Inserts entity in db table, id should be missing and autogenerated
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let test = await db.run('INSERT INTO test (test_name, domain_id, description, date) VALUES (@test_name, @domain_id, @description, CURRENT_DATE)',
            { '@test_name': entity.test_name, '@description': entity.description, '@domain_id': entity.domain_id });

        let questions = [];
        let question_paths = [];
        for (let i = 0; i < entity.questions.length; i++) {
            const question = entity.questions[i];
            question.test_id = test.lastID;
            
            let saved = await question_repository.create(question);
            questions.push(saved);
            question_paths.push('public/items/item-' + saved.lastID + '.xml');
        }
        
        let test_id = test.lastID;
        let promise_list = []
        for (let i = 0; i < entity.professors.length; i++) {
            const professor_id = +entity.professors[i];
            promise_list.push(db.run('INSERT INTO professor_of (u_id, test_id) VALUES (@u_id,@t_id);',
            { '@u_id': professor_id, '@t_id': test_id }));
        }
        for (let i = 0; i < entity.students.length; i++) {
            const student_id = +entity.students[i];
            promise_list.push(db.run('INSERT INTO student_of (u_id, test_id, solved, points) VALUES (@u_id,@t_id, false, @points);',
            { '@u_id': student_id, '@t_id': test_id, '@points': 0 }));
        }
        let res = await Promise.all(promise_list);
        await db.close();

        let obj = {
            'qti-assessment-test': {
                '@xmlns': 'http://www.imsglobal.org/xsd/imsqti_v3p0',
                '@xmlns:xsi': 'http://www.w3.org/2001/XMLSchema-instance',
                '@xsi:schemaLocation': 'http://www.imsglobal.org/xsd/imsqti_v3p0 https://purl.imsglobal.org/spec/qti/v3p0/xsd/imsqti_asiv3p0_v1p0.xsd',
                '@identifier': '' + test.lastID,
                '@title': entity.test_name,
                '@xml:lang': 'en-US',
                'qti-test-part': {
                    '@navigation-mode': 'nonlinear',
                    '@submission-mode': 'individual',
                    '@identifier': 'testPart-1',
                    'qti-assessment-section': {
                        '@identifier': 'assessmentSection-1',
                        '@title': 'Section 1',
                        '@visible': true
                    }
                }
            }
        };

        var root = builder.create(obj);

        for (const ques of questions) {
            root.children[0].children[0].element('qti-assessment-item-ref', { 'identifier': 'item-' + ques.lastID, 'href': 'items/item-' + ques.lastID + '.xml' });
        }

        var xml = root.end({ pretty: true });
        xml = xml.slice(0, 19) + ' encoding="UTF-8"' + xml.slice(19);
        
        if (!fs.existsSync('./public/tests')) {
            fs.mkdirSync('./public/tests', { recursive: true });
        }

        let test_path = 'public/tests/test-' + test.lastID + '.xml';
        fs.writeFileSync(test_path, xml, {flag: 'w'}, err => { if (err) console.error(err); });

        obj = {
            'manifest': {
                '@xmlns': 'http://www.imsglobal.org/xsd/qti/qtiv3p0/imscp_v1p1',
                '@xmlns:xsi': 'http://www.w3.org/2001/XMLSchema-instance',
                '@xsi:schemaLocation': 'http://www.imsglobal.org/xsd/qti/qtiv3p0/imscp_v1p1 https://purl.imsglobal.org/spec/qti/v3p0/schema/xsd/imsqtiv3p0_imscpv1p2_v1p0.xsd',
                '@identifier': 'level1-' + test.lastID,
                'metadata': {
                    'schema': 'QTI Package',
                    'schemaversion': '3.0.0'
                },
                'organizations': {},
                'resources': {}
            }
        };

        root = builder.create(obj);

        for (const ques of questions) {
            var resource = root.children[2].element('resource', { 'identifier': 'item-' + ques.lastID, 'type': 'imsqti_item_xmlv3p0', 'href': 'items/item-' + ques.lastID + '.xml' });
            resource.element('file', { 'href': 'items/item-' + ques.lastID + '.xml' });
        }
        var resource = root.children[2].element('resource', { 'identifier': 'test-' + test.lastID, 'type': 'imsqti_test_xmlv3p0', 'href': 'test-' + test.lastID + '.xml' });
        resource.element('file', { 'href': 'test-' + test.lastID + '.xml' });

        xml = root.end({ pretty: true });
        xml = xml.slice(0, 19) + ' encoding="UTF-8"' + xml.slice(19);

        let manifest_path = 'public/tests/imsmanifest.xml';
        fs.writeFileSync(manifest_path, xml, {flag: 'w'}, err => { if (err) console.error(err); });

        // ----------- Zipping -----------

        var zip = new JSZip();
        var items = zip.folder('items');

        for (const q_path of question_paths) {
            const questiondata = fs.readFileSync(path.join(__dirname, '../', q_path));
            items.file(q_path.substr(q_path.lastIndexOf('/') + 1), questiondata);
        }

        const testdata = fs.readFileSync(path.join(__dirname, '../', test_path));
        zip.file(test_path.substr(test_path.lastIndexOf('/') + 1), testdata);

        const manifestdata = fs.readFileSync(path.join(__dirname, '../', manifest_path));
        zip.file(manifest_path.substr(manifest_path.lastIndexOf('/') + 1), manifestdata);

        zip.generateAsync({ type: 'nodebuffer' }).then(function(content) {
            fs.writeFileSync(path.join(__dirname, `../public/${test.lastID}.zip`), content, { flag: 'w' }, err => { if (err) console.error(err); });
        });

        // fs.rmdir('./public/items', { recursive: true }, (err) => { if (err) { console.error(err); }});
        // fs.rmdir('./public/tests', { recursive: true }, (err) => { if (err) { console.error(err); }});

        return test;
    },
    updateStudentState: async (value, studentid, testid) => {
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        console.log('>>>>>>>>>>>>>>>>')
        await db.run('UPDATE student_of SET student_state = @value WHERE u_id = @u_id AND test_id = @test_id',
                    { '@value': value, '@u_id': studentid, '@test_id': testid });

        await db.close();

    },
    solve: async (entity) => {
        let result = entity.result;

        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT solved FROM student_of WHERE test_id = @test_id AND u_id = @u_id',
            { '@test_id': result.test.id, '@u_id': entity.user.id });

        let solved = await stmt.get().then(solved => solved.solved == true);
        await stmt.finalize();

        if (solved)
            throw new Error('You have already solved this test');

        let promise_list = [];
        let points = 0;
        for (let i = 0; i < result.test.questions.length; i++) {
            const question = result.test.questions[i];
            for (let j = 0; j < question.answered.length; j++) {
                const answer_id = question.answered[j];

                promise_list.push(db.run('INSERT INTO answered_question (u_id, answer_id) VALUES (@u_id, @answer_id)', { '@u_id': entity.user.id, '@answer_id': answer_id }));
            }

            // Calculating test results
            const stmt = await db.prepare('SELECT answer_id FROM correct_answer WHERE question_id = @question_id',
                { '@question_id': question.id });

            let correct_answers = await stmt.all();
            await stmt.finalize();
            
            correct_answers = correct_answers.map(x => x.answer_id);

            if (question.answered.length === correct_answers.length && question.answered.every(id => correct_answers.includes(id))) {
                const stmt = await db.prepare('SELECT points FROM question WHERE id = @id',
                    { '@id': question.id });

                let question_points = await stmt.get().then(res => res.points);
                await stmt.finalize();

                points += question_points;
            }
        }

        let res = await Promise.all(promise_list);

        // Updating the 'student_of' table with points
        await db.run('UPDATE student_of SET solved = true, points = @points WHERE u_id = @u_id AND test_id = @test_id',
                    { '@points': points, '@u_id': entity.user.id, '@test_id': result.test.id });

        await db.close();

        return {points};
    },
    update: (entity) => {
        // Updates entity of given id in db table
    },
    delete: async (id) => {
        // Deletes entity of given id from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let result = await db.run('DELETE FROM test WHERE id = @id',
            { '@id': id });

        await db.close();
        return result;
    },
    exists: async (id) => {
        // Returns True if entity with given id exists in db table, false otherwise
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM test WHERE id = @id',
            { '@id': id });

        let result = await stmt.get();
        await stmt.finalize();

        await db.close();
        return result != null;
    },
    count: async () => {
        // Returns total number of entities in db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM test');

        let result = await stmt.all();
        await stmt.finalize();

        await db.close();
        return result.length;
    },
    findById: async (id) => {
        // Returns entity with given id from db table, null if not existent
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        // TODO: check if user the has already done the test
        var stmt = await db.prepare('SELECT * FROM test WHERE id = @id', { '@id': id });
        let test = await stmt.get();
        await stmt.finalize();

        stmt = await db.prepare('SELECT * FROM question WHERE test_id = @test_id', { '@test_id': test.id });
        let questions = await stmt.all();
        await stmt.finalize();

        for (let i = 0; i < questions.length; i++) {
            let question = questions[i];
            // delete question.test_id;

            stmt = await db.prepare('SELECT * FROM answer WHERE question_id = @question_id', { '@question_id': question.id });
            let answers = await stmt.all();
            await stmt.finalize();

            for (let j = 0; j < answers.length; j++) {
                delete answers[j].isCorrect;
                // delete answers[j].question_id;
            }

            question.answers = answers;
        }

        test.questions = questions;

        await db.close()
        return test;
    },
    getAll: async () => {
        // Returns all entites from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        var stmt = await db.prepare('SELECT * FROM test');
        let tests = await stmt.all();
        await stmt.finalize();

        for (let i = 0; i < tests.length; i++) {
            let test = tests[i];
            
            stmt = await db.prepare('SELECT * FROM question WHERE test_id = @test_id', { '@test_id': test.id });
            let questions = await stmt.all();
            await stmt.finalize();

            for (let j = 0; j < questions.length; j++) {
                let question = questions[j];
                // delete question.test_id;

                stmt = await db.prepare('SELECT * FROM answer WHERE question_id = @question_id', { '@question_id': question.id });
                let answers = await stmt.all();
                await stmt.finalize();

                for (let k = 0; k < answers.length; k++) {
                    delete answers[k].isCorrect;
                    // delete answers[k].question_id;
                }

                question.answers = answers;
            }

            test.questions = questions;
        }

        await db.close()
        return tests;
    },
    getAllForProfessor: async (p_id) => {
        // Returns all entites from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        var stmt = await db.prepare('SELECT test.id, test.test_name, test.description, test.date FROM test INNER JOIN professor_of on test.id = professor_of.test_id WHERE professor_of.u_id = @p_id;', { '@p_id': p_id });
        let tests = await stmt.all();
        await stmt.finalize();

        for (let i = 0; i < tests.length; i++) {
            let test = tests[i];
            
            stmt = await db.prepare('SELECT * FROM question WHERE test_id = @test_id', { '@test_id': test.id });
            let questions = await stmt.all();
            await stmt.finalize();

            for (let j = 0; j < questions.length; j++) {
                let question = questions[j];
                // delete question.test_id;

                stmt = await db.prepare('SELECT * FROM answer WHERE question_id = @question_id', { '@question_id': question.id });
                let answers = await stmt.all();
                await stmt.finalize();

                question.answers = answers;
            }

            test.questions = questions;
        }

        await db.close()
        return tests;
    },
    getAllForStudent: async (s_id) => {
        // Returns all entites from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        var stmt = await db.prepare('SELECT test.id, test.test_name, test.description, test.date, student_of.solved, student_of.points FROM test INNER JOIN student_of on test.id = student_of.test_id WHERE student_of.u_id = @s_id;', { '@s_id': s_id });
        let tests = await stmt.all();
        await stmt.finalize();

        for (let i = 0; i < tests.length; i++) {
            let test = tests[i];
            
            stmt = await db.prepare('SELECT * FROM question WHERE test_id = @test_id', { '@test_id': test.id });
            let questions = await stmt.all();
            await stmt.finalize();

            for (let j = 0; j < questions.length; j++) {
                let question = questions[j];
                // delete question.test_id;

                stmt = await db.prepare('SELECT * FROM answer WHERE question_id = @question_id', { '@question_id': question.id });
                let answers = await stmt.all();
                await stmt.finalize();

                question.answers = answers;
            }

            test.questions = questions;
        }

        await db.close()
        return tests;
    },
    getTestResults: async (p_id, t_id) => {
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });
        
        const stmt = await db.prepare('SELECT user.id AS student_id, user.first_name, user.last_name, test.test_name, test.date, student_of.test_id AS test_id, student_of.points FROM user INNER JOIN user_role ON user.id = user_role.u_id INNER JOIN role on user_role.r_id = role.id INNER JOIN student_of ON student_of.u_id = user.id INNER JOIN test ON student_of.test_id = test.id INNER JOIN professor_of ON professor_of.test_id = test.id WHERE role.role_name = "student" AND student_of.solved = true AND professor_of.u_id = @p_id AND test.id = @t_id;', { '@p_id': p_id, '@t_id': t_id })
        let result = await stmt.all();
        await stmt.finalize();
        
        await db.close()
        return result;
    },
    getStudentState: async (t_id, s_id) => {
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let stmt = await db.prepare('select student_state from student_of where u_id=@u_id and test_id=@t_id and solved=true', {'@u_id': s_id, '@t_id': t_id});
        let result = await stmt.all();
        await stmt.finalize();
        
        await db.close()
        return result;

    },
    getStudentResults: async (id, studentid) => {
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });
        // {
        //     "question_id": 1,
        //     "u_id": 2,
        //     "caid": 1,
        //     "aqid": 1,
        //     "problem_id": 1
        // }

        // const stmt = await db.prepare('select question_id, u_id, ca.answer_id as caid, aq.answer_id as aqid, problem_id from (question as q inner join correct_answer as ca on q.id = ca.question_id) inner join answered_question as aq on ca.answer_id = aq.answer_id where test_id=@id and u_id=@studentid;', { '@id': id, '@studentid': studentid })
        // let result = await stmt.all();
        // await stmt.finalize();

        let stmt = await db.prepare('select question.id as question_id, correct_answer.answer_id as caid, question.problem_id as problem_id from question inner join correct_answer on question.id = correct_answer.question_id where test_id = @id', {'@id': id});
        let result = await stmt.all();
        let aresult = null;
        await stmt.finalize();

        let realdealresults = []
        for (let question of result) {
            let found = realdealresults.find(e => e.question_id == question.question_id);
            if (!found) {
                question.caid = [question.caid]
                realdealresults.push(question)
            }else {
                found.caid.push(question.caid);
            }
        }
        result = realdealresults;

        for (let q of result) {
            stmt = await db.prepare('select answered_question.answer_id as aqid, answered_question.u_id as u_id from answered_question inner join answer on answered_question.answer_id = answer.id where answered_question.u_id = @uid and answer.question_id = @id', {'@uid': studentid, '@id': q.question_id});
            aresult = await stmt.all();
            studentAnswers = JSON.parse(JSON.stringify(aresult));
            q.aqid = studentAnswers.map( e => e.aqid);
            q.u_id = studentid;
            await stmt.finalize();
        }

        await db.close()
        return result;
    },
    getStudentStates: async (test_id) => {
        // count     student_state
        // --------  -------------
        // 1         1,2
        // 1         1,2,3

        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });
        
        const stmt = await db.prepare('select COUNT(*) as count, student_state from student_of where test_id = @tid AND student_state != "" GROUP BY student_state;', { '@tid': test_id})
        let result = await stmt.all();
        await stmt.finalize();
        
        await db.close()
        return result;
    }
}

module.exports = repository;